////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "     "
//  * Details   : http://alexander-bagel.blogspot.ru/2013/05/intercept2.html
//  * Unit Name : uInvalidDialogHook
//  * Purpose   :    
//  * Author    :  (Rouse_) 
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit uInvalidDialogHook;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpliceHelper;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  HotPathSpliceRec: THotPachSpliceData;
  WindowList: TStringList;

function InterceptedCreateWindowExW(dwExStyle: DWORD; lpClassName: PWideChar;
  lpWindowName: PWideChar; dwStyle: DWORD; X, Y, nWidth, nHeight: Integer;
  hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer): HWND; stdcall;
var
  S: string;
  Index: Integer;
begin
  //  
  SpliceLockJmp(HotPathSpliceRec.FuncAddr, HotPathSpliceRec.LockJmp);
  try

    //     
    Index := -1;
    if not IsBadReadPtr(lpClassName, 1) then
    begin
      S := 'ClassName: ' + string(lpClassName);
      S := IntToStr(WindowList.Count + 1) + ': ' + S;
      Index := WindowList.Add(S);
    end;

    //   
    Result := CreateWindowExW(dwExStyle, lpClassName, lpWindowName, dwStyle,
      X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);

    //      
    if Index >= 0 then
    begin
      S := S + ', handle: ' + IntToStr(Result);
      WindowList[Index] := S;
    end;
    
  finally
    //  
    SpliceLockJmp(HotPathSpliceRec.FuncAddr, LOCK_JMP_OPKODE);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //    
  InitHotPatchSpliceRec(user32, 'CreateWindowExW',
    @InterceptedCreateWindowExW, HotPathSpliceRec);
  //     NOP-
  SpliceNearJmp(PAnsiChar(HotPathSpliceRec.FuncAddr) - NearJmpSpliceRecSize,
    HotPathSpliceRec.SpliceRec);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  //  CreateWindowExW
  SpliceLockJmp(HotPathSpliceRec.FuncAddr, LOCK_JMP_OPKODE);
  try
    //          
    WindowList := TStringList.Create;
    try
      //  
      OpenDialog1.Execute;
      //     
      Memo1.Lines.Text := WindowList.Text;
    finally
      WindowList.Free;
    end;
  finally
    //  
    SpliceLockJmp(HotPathSpliceRec.FuncAddr, HotPathSpliceRec.LockJmp);
  end;
end;


end.
