////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "     "
//  * Details   : http://alexander-bagel.blogspot.ru/2013/05/intercept2.html
//  * Unit Name : uWindowTree
//  * Purpose   :    
//  * Author    :  (Rouse_) 
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit uWindowTree;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls;

type
  TdlgWindowTree = class(TForm)
    WindowTreeView: TTreeView;
    procedure FormCreate(Sender: TObject);
  private
    procedure Sys_Windows_Tree(Node: TTreeNode;
      AHandle: HWND; ALevel: Integer);
  end;

var
  dlgWindowTree: TdlgWindowTree;

implementation

{$R *.dfm}

procedure TdlgWindowTree.FormCreate(Sender: TObject);
begin
  Sys_Windows_Tree(nil, GetDesktopWindow, 0);
end;

procedure TdlgWindowTree.Sys_Windows_Tree(Node: TTreeNode;
  AHandle: HWND; ALevel: Integer);
type
  TRootNodeData = record
    Node: TTreeNode;
    PID: Cardinal;
  end;
var
  szClassName, szCaption, szLayoutName: array[0..MAXCHAR - 1] of Char;
  szFileName : array[0..MAX_PATH - 1] of Char;
  Result: String;
  PID, TID: Cardinal;
  I: Integer;
  RootItems: array of TRootNodeData;
  IsNew: Boolean;
begin
  //     
  while AHandle <> 0 do
  begin
    //   
    GetClassName(AHandle, szClassName, MAXCHAR);
    //  ( Caption) 
    GetWindowText(AHandle, szCaption, MAXCHAR);
    //   
    if GetWindowModuleFilename(AHandle, szFileName, SizeOf(szFileName)) = 0 then
      FillChar(szFileName, 256, #0);
    TID := GetWindowThreadProcessId(AHandle, PID);

    //  
    AttachThreadInput(GetCurrentThreadId, TID, True);
    VerLanguageName(GetKeyboardLayout(TID) and $FFFF, szLayoutName, MAXCHAR);
    AttachThreadInput(GetCurrentThreadId, TID, False);

    // 
    Result := Format('%s [%s] Caption = %s, Handle = %d, Layout = %s',
      [String(szClassName), String(szFileName), String(szCaption),
      AHandle, String(szLayoutName)]);

    //      
    if ALevel in [0..1] then
    begin
      IsNew := True;
      for I := 0 to Length(RootItems) - 1 do
        if RootItems[I].PID = PID then
        begin
          Node := RootItems[I].Node;
          IsNew := False;
          Break;
        end;
      if IsNew then
      begin
        SetLength(RootItems, Length(RootItems) + 1);
        RootItems[Length(RootItems) - 1].PID := PID;
        RootItems[Length(RootItems) - 1].Node :=  
          WindowTreeView.Items.AddChild(nil, 'PID: ' + IntToStr(PID));
        Node := RootItems[Length(RootItems) - 1].Node;
      end;
    end;

    //  
    Sys_Windows_Tree(WindowTreeView.Items.AddChild(Node, Result),
      GetWindow(AHandle, GW_CHILD), ALevel + 1);

    //   ( ) 
    AHandle := GetNextWindow(AHandle, GW_HWNDNEXT);
  end;
end;

end.
